'--------------------------------------------------------------
'                     Digitalni obratomer
'--------------------------------------------------------------
'
'                   (C) Sreko Lavri 2001
'
'--------------------------------------------------------------

$crystal = 12000000
$regfile = 89c2051.dat


Dim Clock As Byte , Clock1 As Byte , Mux As Byte
Dim Cnter As Integer , Cnter2 As Integer
Dim Pomozna_v As Integer , 7seg(10) As Byte , Ostanek As Integer
Dim Enice As Byte , Desetice As Byte , Stotice As Byte , Tisocice As Byte
Dim Prikaz As Bit , Izracun As Bit , Osvezi As Byte , Mnozi As Byte

Config Timer0 = Timer , Gate = Internal , Mode = 2

On Timer0 Timer_0_int                          'Podveja Timerja 0
On Int0 Int0_int                               'Podveja prekinitve 0

Load Timer0 , 250                              'Timer naloimo z vrednostjo 250,
Priority Set Int0                              'Int0 nastavimo najvijo prioriteto,
Enable Interrupts                              'Omogoimo prekinitve,
Enable Timer0                                  'Omogoimo Timer0,
Enable Int0                                    'Omogoimo Int0,
Set Tcon.0                                     'Nastavimo, da se prekinitev zgodi samo ob
'negativni fronti signala ter
Start Timer0                                   'zaenemo tudi Timer0

Restore Tabela                                 'Pokaemo na tabelo s podatki
For Pomozna_v = 1 To 10                        'in jih naloimo v spremenljivko.
   Read 7seg(pomozna_v)                        'Podatki nam sluijo za izpis
Next Pomozna_v                                 'na LED displeje.

Clock = 0                                      'Postavimo spremenljivke
Clock1 = 0
Cnter = 0
Cnter2 = 0
Izracun = 1

If P3.1 = 1 Then                               'Doloi faktor mnoenja
   If P3.0 = 1 Then                            'glede na nastavitev
      Mnozi = 30                               'posameznih "jumperjev".
   Else
      Mnozi = 60
   End If
Else
   If P3.0 = 1 Then
      Mnozi = 15
   Else
      Mnozi = 1
   End If
End If

If P1.0 = 1 Then                               'Osveevanje na 1s
   Osvezi = 199
Else
   Osvezi = 99                                 'Potrebno je rezultat
   Mnozi = Mnozi * 2                           'podvojiti za osveevanje
End If                                         'na 0,5s.

Do                                             'in zanemo z neskonno zanko

   If Prikaz = 1 Then                          'Prikaz je omogoen,
      Prikaz = 0
      P3 = 255                                 'ugasni displej,

      If Mux = 0 Then                          'e je na vrsti 1. displej,
         Pomozna_v = Enice + 1                 'doloi vrednost prej. izpisa,
         P1 = 7seg(pomozna_v)                  'postavi port na ustrezno stanje,
         P3.4 = 0                              'vkljui ustrezni displej.
         If Izracun = 1 Then                   'Izraun je omogoen,
            Tisocice = Cnter / 1000            'izraunaj tisoice
            Pomozna_v = Tisocice * 1000        'za naslednji izpis
            Ostanek = Cnter - Pomozna_v
         End If
      End If

      If Mux = 1 Then                          'Enako velje za desetice,
         Pomozna_v = Desetice + 1
         P1 = 7seg(pomozna_v)
         P3.5 = 0
         If Izracun = 1 Then
            Stotice = Ostanek / 100
            Pomozna_v = Stotice * 100
            Ostanek = Ostanek - Pomozna_v
         End If
      End If

      If Mux = 2 Then                          'stotice
         Pomozna_v = Stotice + 1
         P1 = 7seg(pomozna_v)
         P3.3 = 0
         If Izracun = 1 Then
            Desetice = Ostanek / 10
            Pomozna_v = Desetice * 10
            Enice = Ostanek - Pomozna_v
         End If
      End If

      If Mux = 3 Then                          'in tisoice
         Pomozna_v = Tisocice + 1
         P1 = 7seg(pomozna_v)
         P3.7 = 0
      End If
End If

Loop

End


Timer_0_int:                                   'podveja Timer0

   Incr Clock                                  'Poveaj vrednost Clock.(vsakih 250 us)
       If Clock > 19 Then                      'e je 20,
          Clock = 0                            'postavi na 0,
          Prikaz = 1                           'prikai digit.

          Incr Mux                             'Poveaj vrednost Mux.(vsakih 5ms)
          If Mux > 3 Then                      'Ko je 4,
             Mux = 0                           'ga postavi na 0 in
             Izracun = 0                       'konaj izraune.
          End If

          Incr Clock1                          'Poveaj Clock1.
          If Clock1 > Osvezi Then              'Ko je 200 (vsako sekundo)
             Clock1 = 0                        'ga postavi na 0,
             Cnter = Cnter2 * Mnozi            'doloi vrednost za displej
             Cnter2 = 0                        'in resetiraj tevec.
             Izracun = 1                       'Opravi izraune.
          End If
       End If
Return

Int0_int:                                      'Podveja Int0
Incr Cnter2
Return

Tabela:                                        'Podatki o segmentih za LED
Data 16 , 124 , 34 , 40 , 76 , 136 , 128 , 60 , 0 , 8
